﻿Imports NetHIDLibrary.HidControl
Imports GraphicsTable

Public Class Form1


    Const lm35vref As Double = 1800 'mV
    Const lm35res As Double = 10 '10mV/C
    Const max12bit As Double = 4095

    Dim outputBuffer() As Byte

    Private Delegate Sub MarshalToForm(ByVal data() As Byte)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.HidControl1.VendorID = &H1234
        Me.HidControl1.ProductID = &H1
        HidControl1.UseControlTransferOnly = False
        Graph1.Title = "DS1820"
        Graph1.GraphicMode = Drawing2D.SmoothingMode.AntiAlias
        Graph2.Title = "LM35"
        Graph2.GraphicMode = Drawing2D.SmoothingMode.AntiAlias
    End Sub

    Private Sub HidControl1_OnCloseCommunications(sender As Object, msg As String) Handles HidControl1.OnCloseCommunications
        'Me.TextBox1.AppendText("Communication closed at: " & Now().ToShortTimeString & vbCrLf & _
        '" Error Message: " & msg & vbCrLf)
    End Sub

    Private Sub HidControl1_OnDataReceived(sender As Object, data() As Byte) Handles HidControl1.OnDataReceived
        MyMarshalToForm(data)
    End Sub

    Private Sub HidControl1_OnDeviceAttached(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceAttached

        Me.tmrContinuousDataCollect.Start()

        StatusLabel.Text = "Device attached"

    End Sub


    Private Sub HidControl1_OnDeviceDetected(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceDetected
        StatusLabel.Text = "Device detected"
        
        Array.Resize(Me.outputBuffer, e.NUMBER_INPUT_DATA_INDICES)
        tmrContinuousDataCollect.Enabled = True
        tmrContinuousDataCollect.Start()
    End Sub

    Private Sub HidControl1_OnDeviceRemoved(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceRemoved
        tmrContinuousDataCollect.Stop()
        StatusLabel.Text = "Device removed"
    End Sub

    Private Sub tmrContinuousDataCollect_Tick(sender As Object, e As EventArgs) Handles tmrContinuousDataCollect.Tick
        Me.outputBuffer(1) = &HFF 'etc
        HidControl1.ReadAndWriteToDevice(Me.outputBuffer)
    End Sub

    Private Function getTempFromLM35(ByVal Value As UInt16) As Double
        Return CDbl(Value) * lm35vref / max12bit / lm35res
    End Function

    Private Function getTempFromDS1820(ByVal Value As UInt16) As Double
        Dim a, b As Double
        a = CDbl(Value >> 4)
        b = CDbl(CDbl(Value And &HF) * 0.0625)
        Return a + b
    End Function

    Private Sub AccessForm(ByVal data() As Byte)


        Dim tmp As UInt16 = 0

        tmp = data(1) And &HFF
        tmp = (tmp << 8) + data(2)
        Graph1.AddValue(getTempFromDS1820(tmp))

        tmp = 0
        tmp = data(3) And &HFF
        tmp = (tmp << 8) + data(4)
        Graph2.AddValue(getTempFromLM35(tmp))

        'If you need to display ADC value
        'tmp = 0
        'tmp = data(5) And &HFF
        'tmp = (tmp << 8) + data(6)
        'Graph3.AddValue(tmp)

    End Sub

    Private Sub MyMarshalToForm(ByVal data() As Byte)

        Dim args() As Object = {data}

        Dim MarshalToFormDelegate As MarshalToForm

        ' The AccessForm routine contains the code that accesses the form.

        MarshalToFormDelegate = New MarshalToForm(AddressOf AccessForm)

        ' Execute AccessForm, passing the parameters in args.

        MyBase.Invoke(MarshalToFormDelegate, args)

    End Sub

End Class
